# A containerized prototype for developing Hecuba applications

It is useful to prototype using seperate containers for cassandra, a hecuba based producer app and a hecuba based consumer app. Eventually the producer app is an ESM.
Scaling each of these containerized services is envisioned to be reflective of setup on a HPC. For instance, scaling cassandra nodes is like using distributed cassandra nodes, scaling producer app can be ESM model running multiple ensemble members or ESM running on multiple nodes doing parallel IO, likewise for consumer app.


## Overview

Using `docker-compose up -d` in current directory builds/pulls and launces services using containers, among them is 2 cassandra instances: a seed node and other regular cassandra node and a hecuba container used for both producer and consumer. All the services can be scaled later using `docker-compose up -d --scale service_name=n`. For instance,cassandra nodes can be scaled as
`docker-compose up -d --scale cassandra=n` for for a total of n+1 (including seed node) cassandra nodes. Watch out for adding too many nodes on a workstation as memory may not be sufficient.

- To save state of cassandra nodes mount a local dir using volumes directive as ` - './data0:/var/lib/cassandra'` 

- The cassandra seed node is also exposed onto the host, making development of producer and consumer apps on the host easier (where developing code inside containers can be inconvinient/painful). 

- Current hecuba container uses a release version of hecuba from PYPI, avoiding a compilation, this can be replaced by a container in [hecuba gh repo](https://github.com/bsc-dd/hecuba/blob/master/hecuba_container)

- `docker-compose logs hecuba-producer` and like wise, hecuba-consumer can be used to see status of execution for producer and consumer apps, of course can be used to see logs of cassandra too. 

- cassandra command line tools like `nodetool`, `cqlsh` can be used in cassandra services (`cassandra` or `cassandra-seed`). For instance, `docker-compose exec -it cassandra nodetool status` can be used to see list of cassandra nodes.
